/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2001 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.venice.ui;

import java.awt.Dimension;
import java.io.IOException;
import java.io.Writer;
import java.util.Date;
import java.util.Map;
import javax.servlet.ServletException;

public interface RequestOutput extends LinkTypes
{
  public abstract Writer getWriter() throws IOException;

  public abstract void write(String s) throws IOException;

  public abstract void writeStackTrace(Throwable t) throws IOException;

  public abstract void flush() throws IOException;

  public abstract void output(Content c) throws IOException, ServletException;

  public abstract void output(Writer out, Content c) throws IOException, ServletException;

  public abstract void writeFrameHead(Writer out, Content c) throws IOException;

  public abstract void writeFrameHead(Content c) throws IOException;

  public abstract void writeSiteImageTag(Writer out) throws IOException;

  public abstract void writeSiteImageTag() throws IOException;

  public abstract void writeVeniceLogo(Writer out) throws IOException;

  public abstract void writeVeniceLogo() throws IOException;

  public abstract void writeContentHeader(Writer out, String primary, String secondary) throws IOException;

  public abstract void writeContentHeader(String primary, String secondary) throws IOException;

  public abstract String formatURL(String url, int type);

  public abstract String formatDate(Date date);

  public abstract String getColor(int selector);

  public abstract String getColor(String name);

  public abstract String getFontTag(int colorsel, int size);

  public abstract String getFontTag(String color, int size);

  public abstract String getFontTag(int colorsel, String size);

  public abstract String getFontTag(String color, String size);

  public abstract String getStockMessage(String key);

  public abstract String getStockMessage(String key, Map vars);

  public abstract String getStaticPath(String s);

  public abstract String getExternalStaticPath(String s);

  public abstract String getImagePath(String s);

  public abstract String getButtonVisual(String id);

  public abstract String getButtonInput(String id);

  public abstract String getUserPhotoTag(String url);

  public abstract String getUserPhotoTag(String url, Dimension size);

  public abstract String getActivityString(Date date);

  public abstract String getCommunityLogoTag(String url);

} // end interface RequestOutput
